#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf sahlberg-libiscsi-fa4d3aa.tar.gz
    cd sahlberg-libiscsi-fa4d3aa
    sh autogen.sh
    ./configure --prefix=/usr/local --with-pic
    strip -R .note -R .comment lib/.libs/libiscsi.so.1
    mkdir -p ../libiscsi1/lib
    cp lib/.libs/libiscsi.so.1 ../libiscsi1/lib/
    sudo make install
    if [ "$ARCH" = 'amd64' ]; then
	sudo mv /usr/local/lib64/libiscsi.* /usr/local/lib/
	sudo rmdir /usr/local/lib64
    fi
    cd ..
    rm -rf sahlberg-libiscsi-fa4d3aa
}

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
